import Component from '@ember/component'
import { htmlSafe } from '@ember/string'
import { get, computed } from '@ember/object'
import { run } from '@ember/runloop'

import layout from "../templates/components/en-options-wrapper"
import groupBy from "en-select/utils/group-by"

export default Component.extend({
  layout,

  classNames: ["en-select-options"],
  classNameBindings: [
    "isClosing:is-closing",
    "isFixed:is-fixed"
  ],
  attributeBindings: ["role", "style"],

  role: "listbox",
  style: htmlSafe(''),

  groupedOptions: computed("options", "groupByPath", function() {
    let options = get(this, "options")
    let groupByPath = get(this, "groupByPath")

    return groupBy(options, groupByPath)
  }),

  didReceiveAttrs() {
    this._focusOnFirstOption()
  },

  _focusOnFirstOption() {
    let options = get(this, 'options')
    let focused = get(this, 'focused')

    if (options && !options.includes(focused)) {
      run.scheduleOnce('afterRender', this, () => {
        this.attrs['on-focus'](options[0])
      })
    }
  }
})
