import { A } from '@ember/array'
import { isEmpty } from '@ember/utils'
import { get } from '@ember/object'

import stripKeyword from "en-select/utils/strip-keyword"

export default function basicSearch(searchTerm, options, { labelPath }) {
  let searchResults

  if (isEmpty(searchTerm)) {
    searchResults = options
  } else {
    searchResults = options.filter(option => {
      const label = get(option, labelPath).toLowerCase()
      const keyword = searchTerm.toLowerCase()

      return stripKeyword(label).indexOf(stripKeyword(keyword)) >= 0
    })
  }

  return A(searchResults)
}
