import { isEmpty } from "@ember/utils"

const accentMap = {
  á: "a",
  é: "e",
  í: "i",
  ó: "o",
  ú: "u"
}

export default function strip(term) {
  if (isEmpty(term)) {
    return ""
  }

  let modifiedTerm = term
  let pattern = /[^A-Za-z0-9]/g

  Object.keys(accentMap).forEach(item => {
    modifiedTerm = modifiedTerm.replace(item, accentMap[item])
  })

  return modifiedTerm.replace(pattern, "")
}
